// components/autofill/content/common/mojom/autofill_agent.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_AUTOFILL_CONTENT_COMMON_MOJOM_AUTOFILL_AGENT_MOJOM_TEST_UTILS_H_
#define COMPONENTS_AUTOFILL_CONTENT_COMMON_MOJOM_AUTOFILL_AGENT_MOJOM_TEST_UTILS_H_

#include "components/autofill/content/common/mojom/autofill_agent.mojom.h"


namespace autofill::mojom {


class  AutofillAgentInterceptorForTesting : public AutofillAgent {
  virtual AutofillAgent* GetForwardingInterface() = 0;
  void TriggerFormExtraction() override;
  void TriggerFormExtractionWithResponse(TriggerFormExtractionWithResponseCallback callback) override;
  void ApplyFormAction(::autofill::mojom::ActionType action_type, ::autofill::mojom::ActionPersistence action_persistence, ::autofill::FormRendererId form_renderer_id, const std::vector<::autofill::FormFieldData>& fields) override;
  void ApplyFieldAction(::autofill::mojom::ActionPersistence action_persistence, ::autofill::mojom::TextReplacement text_replacement, ::autofill::FieldRendererId field, const ::std::u16string& value) override;
  void ExtractForm(::autofill::FormRendererId form, ExtractFormCallback callback) override;
  void FieldTypePredictionsAvailable(const std::vector<::autofill::FormDataPredictions>& forms) override;
  void ClearSection() override;
  void ClearPreviewedForm() override;
  void TriggerSuggestions(::autofill::FieldRendererId field, ::autofill::mojom::AutofillSuggestionTriggerSource trigger_source) override;
  void SetSuggestionAvailability(::autofill::FieldRendererId field, ::autofill::mojom::AutofillSuggestionAvailability suggestion_availability) override;
  void AcceptDataListSuggestion(::autofill::FieldRendererId field, const ::std::u16string& value) override;
  void PreviewPasswordSuggestion(const ::std::u16string& username, const ::std::u16string& password) override;
  void PreviewPasswordGenerationSuggestion(const ::std::u16string& password) override;
  void SetUserGestureRequired(bool required) override;
  void SetSecureContextRequired(bool required) override;
  void SetFocusRequiresScroll(bool require) override;
  void SetQueryPasswordSuggestion(bool query) override;
  void EnableHeavyFormDataScraping() override;
  void GetPotentialLastFourCombinationsForStandaloneCvc(GetPotentialLastFourCombinationsForStandaloneCvcCallback callback) override;
};
class  AutofillAgentAsyncWaiter {
 public:
  explicit AutofillAgentAsyncWaiter(AutofillAgent* proxy);

  AutofillAgentAsyncWaiter(const AutofillAgentAsyncWaiter&) = delete;
  AutofillAgentAsyncWaiter& operator=(const AutofillAgentAsyncWaiter&) = delete;

  ~AutofillAgentAsyncWaiter();
  void TriggerFormExtractionWithResponse(
      bool* out_success);
  bool TriggerFormExtractionWithResponse();
  void ExtractForm(
      ::autofill::FormRendererId form, std::optional<::autofill::FormData>* out_form);
  std::optional<::autofill::FormData> ExtractForm(::autofill::FormRendererId form);
  void GetPotentialLastFourCombinationsForStandaloneCvc(
      std::vector<std::string>* out_potential_matches);
  std::vector<std::string> GetPotentialLastFourCombinationsForStandaloneCvc();

 private:
  AutofillAgent* const proxy_;
};


class  PasswordAutofillAgentInterceptorForTesting : public PasswordAutofillAgent {
  virtual PasswordAutofillAgent* GetForwardingInterface() = 0;
  void SetPasswordFillData(const ::autofill::PasswordFormFillData& form_data) override;
  void FillPasswordSuggestion(const ::std::u16string& username, const ::std::u16string& password) override;
  void InformNoSavedCredentials(bool should_show_popup_without_passwords) override;
  void FillIntoFocusedField(bool is_password, const ::std::u16string& credential) override;
  void SetLoggingState(bool active) override;
  void AnnotateFieldsWithParsingResult(const ::autofill::ParsingResult& parsing_result) override;
};
class  PasswordAutofillAgentAsyncWaiter {
 public:
  explicit PasswordAutofillAgentAsyncWaiter(PasswordAutofillAgent* proxy);

  PasswordAutofillAgentAsyncWaiter(const PasswordAutofillAgentAsyncWaiter&) = delete;
  PasswordAutofillAgentAsyncWaiter& operator=(const PasswordAutofillAgentAsyncWaiter&) = delete;

  ~PasswordAutofillAgentAsyncWaiter();

 private:
  PasswordAutofillAgent* const proxy_;
};


class  PasswordGenerationAgentInterceptorForTesting : public PasswordGenerationAgent {
  virtual PasswordGenerationAgent* GetForwardingInterface() = 0;
  void GeneratedPasswordAccepted(const ::std::u16string& generated_password) override;
  void TriggeredGeneratePassword(TriggeredGeneratePasswordCallback callback) override;
  void FoundFormEligibleForGeneration(const ::autofill::PasswordFormGenerationData& form) override;
  void FocusNextFieldAfterPasswords() override;
};
class  PasswordGenerationAgentAsyncWaiter {
 public:
  explicit PasswordGenerationAgentAsyncWaiter(PasswordGenerationAgent* proxy);

  PasswordGenerationAgentAsyncWaiter(const PasswordGenerationAgentAsyncWaiter&) = delete;
  PasswordGenerationAgentAsyncWaiter& operator=(const PasswordGenerationAgentAsyncWaiter&) = delete;

  ~PasswordGenerationAgentAsyncWaiter();
  void TriggeredGeneratePassword(
      std::optional<::autofill::password_generation::PasswordGenerationUIData>* out_data);
  std::optional<::autofill::password_generation::PasswordGenerationUIData> TriggeredGeneratePassword();

 private:
  PasswordGenerationAgent* const proxy_;
};




}  // autofill::mojom

#endif  // COMPONENTS_AUTOFILL_CONTENT_COMMON_MOJOM_AUTOFILL_AGENT_MOJOM_TEST_UTILS_H_