// content/common/pepper_plugin.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CONTENT_COMMON_PEPPER_PLUGIN_MOJOM_TEST_UTILS_H_
#define CONTENT_COMMON_PEPPER_PLUGIN_MOJOM_TEST_UTILS_H_

#include "content/common/pepper_plugin.mojom.h"
#include "content/common/content_export.h"


namespace content::mojom {


class CONTENT_EXPORT PepperHostInterceptorForTesting : public PepperHost {
  virtual PepperHost* GetForwardingInterface() = 0;
  void InstanceCreated(int32_t instance_id, ::mojo::PendingAssociatedRemote<PepperPluginInstance> instance, ::mojo::PendingAssociatedReceiver<PepperPluginInstanceHost> host) override;
  void BindHungDetectorHost(::mojo::PendingReceiver<PepperHungDetectorHost> host, int32_t plugin_child_id, const ::base::FilePath& plugin_path) override;
  void GetPluginInfo(const ::GURL& url, const std::string& mime_type, GetPluginInfoCallback callback) override;
  void DidCreateInProcessInstance(int32_t instance_id, int32_t frame_routing_id, const ::GURL& document_url, const ::GURL& plugin_url) override;
  void DidDeleteInProcessInstance(int32_t instance_id) override;
  void DidCreateOutOfProcessPepperInstance(int32_t plugin_child_id, int32_t pp_instance, bool is_external, int32_t frame_routing_id, const ::GURL& document_url, const ::GURL& plugin_url, bool is_privileged_context, DidCreateOutOfProcessPepperInstanceCallback callback) override;
  void DidDeleteOutOfProcessPepperInstance(int32_t plugin_child_id, int32_t pp_instance, bool is_external) override;
  void OpenChannelToPepperPlugin(const ::url::Origin& embedder_origin, const ::base::FilePath& path, const std::optional<::url::Origin>& origin_lock, OpenChannelToPepperPluginCallback callback) override;
};
class CONTENT_EXPORT PepperHostAsyncWaiter {
 public:
  explicit PepperHostAsyncWaiter(PepperHost* proxy);

  PepperHostAsyncWaiter(const PepperHostAsyncWaiter&) = delete;
  PepperHostAsyncWaiter& operator=(const PepperHostAsyncWaiter&) = delete;

  ~PepperHostAsyncWaiter();
  void GetPluginInfo(
      const ::GURL& url, const std::string& mime_type, bool* out_found, ::content::WebPluginInfo* out_plugin_info, std::string* out_actual_mime_type);
  
  void DidCreateOutOfProcessPepperInstance(
      int32_t plugin_child_id, int32_t pp_instance, bool is_external, int32_t frame_routing_id, const ::GURL& document_url, const ::GURL& plugin_url, bool is_privileged_context);
  
  void OpenChannelToPepperPlugin(
      const ::url::Origin& embedder_origin, const ::base::FilePath& path, const std::optional<::url::Origin>& origin_lock, ::mojo::ScopedMessagePipeHandle* out_handle_to_channel, ::base::ProcessId* out_plugin_pid, int32_t* out_plugin_child_id);
  

 private:
  PepperHost* const proxy_;
};


class CONTENT_EXPORT PepperHungDetectorHostInterceptorForTesting : public PepperHungDetectorHost {
  virtual PepperHungDetectorHost* GetForwardingInterface() = 0;
  void PluginHung(bool is_hung) override;
};
class CONTENT_EXPORT PepperHungDetectorHostAsyncWaiter {
 public:
  explicit PepperHungDetectorHostAsyncWaiter(PepperHungDetectorHost* proxy);

  PepperHungDetectorHostAsyncWaiter(const PepperHungDetectorHostAsyncWaiter&) = delete;
  PepperHungDetectorHostAsyncWaiter& operator=(const PepperHungDetectorHostAsyncWaiter&) = delete;

  ~PepperHungDetectorHostAsyncWaiter();

 private:
  PepperHungDetectorHost* const proxy_;
};


class CONTENT_EXPORT PepperPluginInstanceHostInterceptorForTesting : public PepperPluginInstanceHost {
  virtual PepperPluginInstanceHost* GetForwardingInterface() = 0;
  void StartsPlayback() override;
  void StopsPlayback() override;
  void InstanceCrashed(const ::base::FilePath& plugin_path, ::base::ProcessId plugin_pid) override;
};
class CONTENT_EXPORT PepperPluginInstanceHostAsyncWaiter {
 public:
  explicit PepperPluginInstanceHostAsyncWaiter(PepperPluginInstanceHost* proxy);

  PepperPluginInstanceHostAsyncWaiter(const PepperPluginInstanceHostAsyncWaiter&) = delete;
  PepperPluginInstanceHostAsyncWaiter& operator=(const PepperPluginInstanceHostAsyncWaiter&) = delete;

  ~PepperPluginInstanceHostAsyncWaiter();

 private:
  PepperPluginInstanceHost* const proxy_;
};


class CONTENT_EXPORT PepperPluginInstanceInterceptorForTesting : public PepperPluginInstance {
  virtual PepperPluginInstance* GetForwardingInterface() = 0;
  void SetVolume(double volume) override;
};
class CONTENT_EXPORT PepperPluginInstanceAsyncWaiter {
 public:
  explicit PepperPluginInstanceAsyncWaiter(PepperPluginInstance* proxy);

  PepperPluginInstanceAsyncWaiter(const PepperPluginInstanceAsyncWaiter&) = delete;
  PepperPluginInstanceAsyncWaiter& operator=(const PepperPluginInstanceAsyncWaiter&) = delete;

  ~PepperPluginInstanceAsyncWaiter();

 private:
  PepperPluginInstance* const proxy_;
};




}  // content::mojom

#endif  // CONTENT_COMMON_PEPPER_PLUGIN_MOJOM_TEST_UTILS_H_